#include "Skybox.h"
#include <cmath>
#include <fstream>
#include <iostream>
#include <QMessageBox>
#include "Model.h"

using namespace std;

Skybox::Skybox() {

    // the position buffer
    positionBuffer = QGLBuffer(QGLBuffer::VertexBuffer);
    positionBuffer.setUsagePattern(QGLBuffer::StaticDraw);
    positionBuffer.create();
    positionBuffer.bind();
    positionBuffer.allocate(&positions[0],
                            positions.size() * sizeof(QVector3D));
    positionBuffer.release();

  // An dieser Stelle wird wieder die nullte Texturebene genutzt.
  glActiveTexture(GL_TEXTURE0);

  skyImages.resize(6);

  skyImages[0] = std::unique_ptr<QImage>(new QImage(
      QString("skybox/right.png")));
  skyImages[1] =
      std::unique_ptr<QImage>(new QImage(QString("skybox/back.png")));
  skyImages[2] = std::unique_ptr<QImage>(
      new QImage(QString("skybox/down.png")));
  skyImages[3] = std::unique_ptr<QImage>(new QImage(
      QString("skybox/front.png")));
  skyImages[4] = std::unique_ptr<QImage>(
      new QImage(QString("skybox/left.png")));
  skyImages[5] = std::unique_ptr<QImage>(new QImage(QString("skybox/up.png")));


}

void Skybox::render(std::shared_ptr<QOpenGLShaderProgram> program, QVector3D cameraPosition) {

 }
